
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Android--UI之Spinner / 憋错料</title>

    <meta name="description" content="Android--UI之Spinner 前言 最近一直在讲AndroidUI的开发,今天讲一下Spinner控件,这是一个列表选择框,可以弹出一个列表供用户选择.在本片博客中,会讲解Spinner的基本属性以及设置之后的效果,以及使用SimpleAdapter绑定自定义格式的数据到Spinner中. Spinner Spinner 是一个列表选择框,会在用户选择后,展示一个列表供用户进行选择.Spinner是ViewGroup的间接子类,它和其他的Android控件一样,数据需要使用Adapter进行封装. 下面介绍一下Spinner">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Android--UI之Spinner</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p><strong>前言</strong></p>
<p>最近一直在讲AndroidUI的开发，今天讲一下Spinner控件，这是一个列表选择框，可以弹出一个列表供用户选择。在本片博客中，会讲解Spinner的基本属性以及设置之后的效果，以及使用SimpleAdapter绑定自定义格式的数据到Spinner中。</p>
<p><strong>Spinner</strong></p>
<p><a href="http://developer.android.com/reference/android/widget/Spinner.html" rel="external nofollow noreferrer">Spinner</a>&nbsp;是一个列表选择框，会在用户选择后，展示一个列表供用户进行选择。Spinner是ViewGroup的间接子类，它和其他的Android控件一样，数据需要使用Adapter进行封装。</p>
<p>下面介绍一下Spinner的常用XML属性，Android也为其属性提供了相应的getter、setter方法：</p>
<ul>
<li>android:spinnerMode：列表显示的模式，有两个选择，为弹出列表（dialog）以及下拉列表（dropdown），如果不特别设置，为下拉列表。。</li>
<li>android:entries：使用&lt;string-array.../&gt;资源配置数据源。</li>
<li>android:prompt：对当前下拉列表设置标题，仅在dialog模式下有效。传递一个&ldquo;@string/name&rdquo;资源，需要在需要在资源文件中定义&lt;string.../&gt;。</li>
</ul>
<p>作为一个列表选择控件，Spinner具有一些选中选项可以触发的事件，但它本身没有定义这些事件，均继承自间接父类&nbsp;<a href="http://developer.android.com/reference/android/widget/AdapterView.html" rel="external nofollow noreferrer">AdapterView</a>&nbsp;。Spinner支持的几个常用事件有以下几个：</p>
<ul>
<li>AdapterView.OnItemCLickListener：列表项被点击时触发。</li>
<li>AdapterView.OnItemLongClickListener：列表项被长按时触发。</li>
<li>AdapterView.OnItemSelectedListener：列表项被选择时触发。</li>
</ul>
<p>PS：因为适配器可以设置各种不同的样式，有选择、单选、多选，所以OnItemCLickListener和OnItemSelectedListener是适用于不同场景的。</p>
<p><strong>Spinner的数据绑定</strong></p>
<p>对于Spinner展示的数据源，一般使用两种方式设定数据：</p>
<ul>
<li>通过XML资源文件设置，这种方式比较死板，但是如果仅仅需要展示固定的、简单的数据，这种方式还是可以考虑的，比较直观。</li>
<li>使用Adapter接口设置，这是最常见的方式，动态、灵活，可以设定各种样式以及数据来源。</li>
</ul>
<p>先来讲讲通过XML资源文件设置Spinner数据的方式，首先需要在/res/values目录下新建XML格式的资源文件，名字不重要，但是一般会使用strings.xml。在其中的&lt;resourse.../&gt;标签下，定义&lt;string-array.../&gt;标签，通过它中的&lt;item.../&gt;标签来设置选择数据。</p>
<p>XML文件结构：</p>
<p>&lt;resource&gt;</p>
<p>&lt;string-array name="arrayname"&gt;</p>
<p>&lt;item&gt;item1&lt;/item&gt;</p>
<p>&lt;item&gt;item2&lt;/item&gt;</p>
<p>&lt;item&gt;item3&lt;/item&gt;</p>
<p>&lt;/string-array&gt;</p>
<p>&lt;resource&gt;</p>
<p>通过适配器Adapter可以设定比较复杂的展示效果，一般项目中比较常用的也是这种方式。但是如果对于动态的、简单的数据，可以使用ArrayAdapter对象来设置适配器，关于ArrayAdapter类的介绍，在我的另外一篇博客中有介绍，不了解的朋友可以先看看：&nbsp;<a href="http://www.cnblogs.com/plokmju/p/android_UI_AutoCompleteTextView.html" rel="external nofollow noreferrer">Android--UI之AutoCompleteTextView</a>&nbsp;。</p>
<p>下面通过一个示例，讲解一下上面说的属性、事件，以及使用ArrayAdapter和XML资源文件设定简单数据，代码中注释已经说的很清楚了，这里就不再累述了。</p>
<p>布局代码：</p>
<pre> 1 &lt;?xml version="1.0" encoding="utf-8"?&gt;
 2 &lt;LinearLayout xmlns:android="http://schemas.android.com/apk/res/android"
 3     android:layout_width="match_parent"
 4     android:layout_height="match_parent"
 5     android:orientation="vertical" &gt;
 6
 7     &lt;TextView
 8         android:layout_width="wrap_content"
 9         android:layout_height="wrap_content"
10         android:text="弹出的Spinner" /&gt;
11
12     &lt;Spinner
13         android:id="@+id/spinnerBase"
14         android:layout_width="match_parent"
15         android:layout_height="wrap_content"
16         android:spinnerMode="dialog" /&gt;
17
18     &lt;TextView
19         android:layout_width="wrap_content"
20         android:layout_height="wrap_content"
21         android:text="下拉的Spinner（默认）" /&gt;
22
23     &lt;Spinner
24         android:id="@+id/spinnerBase1"
25         android:layout_width="match_parent"
26         android:layout_height="wrap_content"
27         android:spinnerMode="dropdown" /&gt;
28
29     &lt;TextView
30         android:layout_width="wrap_content"
31         android:layout_height="wrap_content"
32         android:text="entries绑定数据源" /&gt;
33
34     &lt;Spinner
35         android:id="@+id/spinnerBase2"
36         android:layout_width="match_parent"
37         android:layout_height="wrap_content"
38         android:entries="@array/beijing" /&gt;
39
40     &lt;TextView
41         android:layout_width="wrap_content"
42         android:layout_height="wrap_content"
43         android:text="弹出带标题的Dialog，并且使用entries绑定数据源" /&gt;
44
45     &lt;Spinner
46         android:id="@+id/spinnerBase3"
47         android:layout_width="match_parent"
48         android:layout_height="wrap_content"
49         android:entries="@array/beijing"
50         android:prompt="@string/beij_prompt"
51         android:spinnerMode="dialog" /&gt;
52
53 &lt;/LinearLayout&gt;</pre>
<p>实现代码：</p>
<pre> 1 package com.bgxt.datatimepickerdemo;
 2
 3 import java.util.ArrayList;
 4 import java.util.List;
 5
 6 import android.app.Activity;
 7 import android.os.Bundle;
 8 import android.view.View;
 9 import android.widget.AdapterView;
10 import android.widget.AdapterView.OnItemSelectedListener;
11 import android.widget.ArrayAdapter;
12 import android.widget.Spinner;
13 import android.widget.Toast;
14
15 public class SpinnerBaseActivity extends Activity {
16     private Spinner spinner1, spinner2;
17
18     @Override
19     protected void onCreate(Bundle savedInstanceState) {
20         super.onCreate(savedInstanceState);
21         setContentView(R.layout.activity_spinnerbase);
22
23         spinner1 = (Spinner) findViewById(R.id.spinnerBase);
24         spinner2 = (Spinner) findViewById(R.id.spinnerBase1);
25         // 声明一个ArrayAdapter用于存放简单数据
26         ArrayAdapter&lt;String&gt; adapter = new ArrayAdapter&lt;String&gt;(
27                 SpinnerBaseActivity.this, android.R.layout.simple_spinner_item,
28                 getData());
29         // 把定义好的Adapter设定到spinner中
30         spinner1.setAdapter(adapter);
31         spinner2.setAdapter(adapter);
32         // 为第一个Spinner设定选中事件
33         spinner1.setOnItemSelectedListener(new OnItemSelectedListener() {
34
35             @Override
36             public void onItemSelected(AdapterView&lt;?&gt; parent, View view,
37                     int position, long id) {
38                 // 在选中之后触发
39                 Toast.makeText(SpinnerBaseActivity.this,
40                         parent.getItemAtPosition(position).toString(),
41                         Toast.LENGTH_SHORT).show();
42             }
43
44             @Override
45             public void onNothingSelected(AdapterView&lt;?&gt; parent) {
46                 // 这个一直没有触发，我也不知道什么时候被触发。
47                 //在官方的文档上说明，为back的时候触发，但是无效，可能需要特定的场景
48             }
49         });
50
51     }
52
53     private List&lt;String&gt; getData() {
54         // 数据源
55         List&lt;String&gt; dataList = new ArrayList&lt;String&gt;();
56         dataList.add("北京");
57         dataList.add("上海");
58         dataList.add("南京");
59         dataList.add("宜昌");
60         return dataList;
61     }
62
63 }</pre>
<p>XML资源文件：</p>
<pre> 1 &lt;?xml version="1.0" encoding="utf-8"?&gt;
 2 &lt;resources&gt;
 3     &lt;string name="app_name"&gt;SpinnerDemo&lt;/string&gt;
 4     &lt;string name="action_settings"&gt;Settings&lt;/string&gt;
 5     &lt;string name="hello_world"&gt;Hello world!&lt;/string&gt;
 6     &lt;string name="beij_prompt"&gt;北京区域&lt;/string&gt;
 7     &lt;string-array name="beijing"&gt;
 8         &lt;item&gt;朝阳区&lt;/item&gt;
 9         &lt;item&gt;海淀区&lt;/item&gt;
10         &lt;item&gt;房山区&lt;/item&gt;
11         &lt;item&gt;丰台区&lt;/item&gt;
12         &lt;item&gt;东城区&lt;/item&gt;
13         &lt;item&gt;西城区&lt;/item&gt;
14     &lt;/string-array&gt;
15 &lt;/resources&gt;</pre>
<p>效果展示，图片顺序，从上到下：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nMC50dWljb29sLmNvbS9pSXY2dmUucG5n.jpg" />&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nMS50dWljb29sLmNvbS9iWXJhWWIucG5n.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nMC50dWljb29sLmNvbS9tYWFlYWkucG5n.jpg" />&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nMC50dWljb29sLmNvbS9yTUpOYm0ucG5n.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nMi50dWljb29sLmNvbS9JRlZ6WW4ucG5n.jpg" /></p>
<p><strong>SimpleAdapter配置Spinner数据</strong></p>
<p>对于一个稍复杂的数据，如果想对其展示，光使用ArrayAdapter是无法满足需求的，现在在另外介绍一个Adapter，&nbsp;<a href="http://developer.android.com/reference/android/widget/SimpleAdapter.html" rel="external nofollow noreferrer">SimpleAdapter</a>&nbsp;，同样继承自Adapter。</p>
<p>SimpleAdapter是一个简单的适配器，映射静态的XML格式的布局文件到视图中。可以指定一个List&lt;Map&lt;P,T&gt;&gt;格式的数据，List中的每一条数据对应一行，而Map中的每一条数据对应数据行的一列。这个数据用来映射到XML定义的布局控件中，对应关系通过构造函数的另外两个参数来指定，现在来介绍一下SimpleAdapter的构造函数。</p>
<p>SimpleAdapter(Context context, List&lt;? extends Map&lt;String, ?&gt;&gt; data, int resource, String[] from, int[] to)</p>
<ul>
<li>context：上下文对象，没什么好说的，一般就是当前的Activity。</li>
<li>data：上面介绍的List&lt;Map&lt;S,T&gt;&gt;类型的数据。</li>
<li>resource：XML资源的Id，通过R对象选中。</li>
<li>from：一个String类型数组，每条数据对应data数据中，Map结构定义的Key。</li>
<li>to：一个int类型数组，对应XML资源中控件的ID，注意顺序必须与from中指定数据的顺序一致。</li>
</ul>
<p>下面通过一个示例讲解一下SimpleAdapter是如何设置自定义格式数据的。</p>
<p>布局代码：</p>
<pre>1 &lt;?xml version="1.0" encoding="utf-8"?&gt;
2 &lt;LinearLayout xmlns:android="http://schemas.android.com/apk/res/android"
3     android:layout_width="match_parent"
4     android:layout_height="match_parent"
5     android:orientation="vertical" &gt;
6
7 &lt;Spinner android:id="@+id/spinnerAdapter" android:layout_width="match_parent"
8     android:layout_height="wrap_content" /&gt;
9 &lt;/LinearLayout&gt;</pre>
<p>XML布局资源代码：</p>
<pre> 1 &lt;?xml version="1.0" encoding="utf-8"?&gt;
 2 &lt;LinearLayout xmlns:android="http://schemas.android.com/apk/res/android"
 3     android:layout_width="match_parent"
 4     android:layout_height="wrap_content"
 5     android:orientation="horizontal" &gt;
 6
 7     &lt;ImageView
 8         android:id="@+id/imageview"
 9         android:layout_width="60dp"
10         android:layout_height="60dp"
11         android:paddingLeft="10dp"
12         android:src="@drawable/ic_launcher" /&gt;
13
14     &lt;TextView
15         android:id="@+id/textview"
16         android:layout_width="match_parent"
17     android:layout_height="wrap_content"
18         android:gravity="center_vertical"
19         android:paddingLeft="10dp"
20         android:textColor="#000"
21         android:textSize="16dp" /&gt;
22
23 &lt;/LinearLayout&gt;</pre>
<p>实现代码：</p>
<pre> 1 package com.bgxt.datatimepickerdemo;
 2
 3 import java.util.ArrayList;
 4 import java.util.HashMap;
 5 import java.util.List;
 6 import java.util.Map;
 7
 8 import android.app.Activity;
 9 import android.os.Bundle;
10 import android.view.View;
11 import android.widget.AdapterView;
12
13 import android.widget.AdapterView.OnItemSelectedListener;
14 import android.widget.SimpleAdapter;
15 import android.widget.Spinner;
16 import android.widget.Toast;
17
18 public class SpinnerAdapterActivity extends Activity {
19     private Spinner spinner;
20
21     @Override
22     protected void onCreate(Bundle savedInstanceState) {
23         // TODO Auto-generated method stub
24         super.onCreate(savedInstanceState);
25         setContentView(R.layout.activity_spinneradapter);
26
27         spinner = (Spinner) findViewById(R.id.spinnerAdapter);
28         //声明一个SimpleAdapter独享，设置数据与对应关系
29         SimpleAdapter simpleAdapter = new SimpleAdapter(
30                 SpinnerAdapterActivity.this, getData(), R.layout.items,
31                 new String[] { "ivLogo", "applicationName" }, new int[] {
32                         R.id.imageview, R.id.textview });
33         //绑定Adapter到Spinner中
34         spinner.setAdapter(simpleAdapter);
35         //Spinner被选中事件绑定。
36         spinner.setOnItemSelectedListener(new OnItemSelectedListener() {
37
38             @Override
39             public void onItemSelected(AdapterView&lt;?&gt; parent, View view,
40                     int position, long id) {
41                 //parent为一个Map结构的和数据
42                 Map&lt;String, Object&gt; map = (Map&lt;String, Object&gt;) parent
43                         .getItemAtPosition(position);
44                 Toast.makeText(SpinnerAdapterActivity.this,
45                         map.get("applicationName").toString(),
46                         Toast.LENGTH_SHORT).show();
47             }
48
49             @Override
50             public void onNothingSelected(AdapterView&lt;?&gt; arg0) {
51
52             }
53         });
54     }
55
56     public List&lt;Map&lt;String, Object&gt;&gt; getData() {
57         //生成数据源
58         List&lt;Map&lt;String, Object&gt;&gt; list = new ArrayList&lt;Map&lt;String, Object&gt;&gt;();
59         //每个Map结构为一条数据，key与Adapter中定义的String数组中定义的一一对应。
60         Map&lt;String, Object&gt; map = new HashMap&lt;String, Object&gt;();
61         map.put("ivLogo", R.drawable.bmp1);
62         map.put("applicationName", "表情1");
63         list.add(map);
64         Map&lt;String, Object&gt; map2 = new HashMap&lt;String, Object&gt;();
65         map2.put("ivLogo", R.drawable.bmp2);
66         map2.put("applicationName", "表情2");
67         list.add(map2);
68         Map&lt;String, Object&gt; map3 = new HashMap&lt;String, Object&gt;();
69         map3.put("ivLogo", R.drawable.bmp3);
70         map3.put("applicationName", "表情3");
71         list.add(map3);
72         return list;
73     }
74 }</pre>
<p>效果展示：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nMS50dWljb29sLmNvbS9ZSmZRVjMucG5n.jpg" />&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nMC50dWljb29sLmNvbS9uMlVOcnkucG5n.jpg" /></p>
<p><a href="http://download.csdn.net/detail/plokmju88/5822221" rel="external nofollow noreferrer">源码下载</a></p>
<p>请支持原创，尊重原创，转载请注明出处。谢谢。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-29 15:19:35 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Android--UI之Spinner的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4NoZ5VM.html" rel="bookmark">Android UI自定义Spinner下拉框（用popuwindow实现）-转</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				定义出第一个图片的布局和弹出框(一个listView)的布局,,这里就不在多说了~ListView需要自己定义一个MyspinnerAdapter~做好这些准备之后,就是弹出框的实现了~  protected void onCreate(Bundle savedInstanceState) { 03         super.onCreate(savedInstanceState); 04         setContentView(R.layout.activity_main); 05  			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0j1wgZM.html" rel="bookmark">10款实用Android UI工具库</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				移动应用的UI设计就好似达摩克利斯之剑,一方面,一个视觉.交互.体验良好的UI可以加强应用在用户心目中的形象和识别性.而另一方面,一个体验糟糕的UI设计不仅无法让用户沉浸在应用中,还会造成用户对应用产生厌恶感.所以说在进行应用开发时,一个高质量的UI对于提高应用下载量有着非常重要的作用.对此,本文特为广大的移动应用开发者献上10款非常实用的Android UI设计工具. ActionBarSherlock:一个独立的设计库,也是GitHub上很火的一个开源项目 Nine Old Androids			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Moo9VyM.html" rel="bookmark">Android UI相关开源项目库汇总</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				最近做了一个Android UI相关开源项目库汇总,里面集合了OpenDigg 上的优质的Android开源项目库,方便移动开发人员便捷的找到自己需要的项目工具等,感兴趣的可以到GitHub上给个star. 抽屉菜单 MaterialDrawer ★7337 - 安卓抽屉效果实现方案 Side-Menu.Android ★3865 - 创意边侧菜单 FlowingDrawer ★1744 - 向右滑动流动抽屉效果 SlidingRootNav ★1338 - 仿DrawerLayout的View			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0axgvJM.html" rel="bookmark">向产品宣战&mdash;&mdash;开发者眼中的Android UI Design</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				向产品宣战--开发者眼中的Android UI Design 准备了半个月,思考产品设计.交互设计,见证了公司的产品.UE和开发的撕逼,将自己的思考.感悟,整理成下文,谨代表广大程序猿,向设计狮.产品X开战.希望广大程序猿能够坚持贯彻Google的Material Design,切实认真负责的执行Android的设计思想,将MD设计带到产品中去,不做中国特色的App,将Android的开发风气带到正轨,树立正确的开发观.设计观. 希望广大程序猿朋友在博客后面留言.签名,规范Android设计.树			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4JbgQY4.html" rel="bookmark">Android UI布局与控件（二）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.View类的常用xml属性:[了解] ①.Android中所有的UI(用户界面)元素都是使用View和ViewGroup对象建立的 ②.View是一个可以将一些信息绘制在屏幕上并与用户产生交互的对象 ③.ViewGroup是一个包含多个的View和ViewGroup的容器,用来定义UI布局. ④.Android提供了一系列的View和ViewGroup的子类,开发者可以灵活地组合使用它们来完成界面布 局.界 面元素绘制和用户交互等工作 ⑤.开发者还可以选择性地继承一些系统提供的View,来自			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/41XvLX3.html" rel="bookmark">腾讯出品的一个超棒的 Android UI 库</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				腾讯出品的一个超棒的 Android UI 库 相信做 Android 久了大家都会有种体会,那就是 Android 开发相对于前端开发来说统一的 UI 开源库比较少.造成这种现象的原因一方面是大多数 App 都有自己的 UI 风格,另一方面也是因为开源这种 UI 库费事费力而且很难受到关注,可以说是吃力不讨好. 正因如此,今天这个 UI 库就显得特别值得关注了.它提供了一系列常用的组件和丰富多彩的样式主题,比如最常见的 TextView.Button.EditText.ImageView.Sp			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/pMPBnv3.html" rel="bookmark">Android UI设计之&amp;lt&semi;十&amp;gt&semi;自定义ListView，实现QQ空间阻尼下拉刷新和渐变菜单栏效果</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转载请注明出处:http://blog.csdn.net/llew2011/article/details/51559694 好久没有写有关UI的博客了,刚刚翻了一下之前的博客,最近一篇有关UI的博客是在2014年写的:Android UI设计之&lt;七&gt;自定义Dialog,实现各种风格效果的对话框,在那篇博客写完后由于公司封闭开发封网以及其它原因致使博客中断至今,中断这么久很是惭愧,后续我会尽量把该写的都补充出来.近来项目有个需求,要做个和QQ空间类似的菜单栏透明度渐变和下拉刷新带有阻尼回弹的效			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MGG7waM.html" rel="bookmark">【转】Android UI系列-----时间、日期、Toasts和进度条Dialog</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文网址:http://www.cnblogs.com/xiaoluo501395377/p/3421727.html 您可以通过点击 右下角 的按钮 来对文章内容作出评价, 也可以通过左下方的 关注按钮 来关注我的博客的最新动态. 如果文章内容对您有帮助, 不要忘记点击右下角的 推荐按钮 来支持一下哦 如果您对文章内容有任何疑问, 可以通过评论或发邮件的方式联系我: [email protected] / [email protected] 如果需要转载,请注明出处,谢谢!! 本篇随笔将继续学			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MoQe7b3.html" rel="bookmark">Android UI学习 - ListView &lpar;android&period;R&period;layout&period;simple&lowbar;list&lowbar;item&lowbar;1是个什么东西&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Android UI学习 - ListView 2010-06-20 18:21:35 标签:Android UI 移动开发 ListView ListActivity 原创作品,允许转载,转载时请务必以超链接形式标明文章 原始出处 .作者信息和本声明.否则将追究法律责任.http://android.blog.51cto.com/268543/336162 ListActivity ListActivity是一个专门显示ListView的Activity类,它内置了ListView对象,只要我			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3wrGmR0.html" rel="bookmark">Android UI组件进阶&lpar;2&rpar;&mdash;&mdash;仿Windows对话框</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Android UI组件进阶(2)--仿Windows对话框 在开始本章前先祝大家中秋节快乐哈,相信很多上班的朋友都是放三天假的哈! 有时间的话回家陪陪父母吧!树欲静而风不止,子欲养而亲不待!岁月不饶人! 好了,道理和祝福语就说到这里了,今天给大家准备的是模仿Windows风格对话框! 效果图: 相信大部分的AlertDialog都是下面这个样子的: 今天给大家讲解的对话框是下面这样的: 对比两种对话框,站在用户的角度,相信你更加钟情于第二种颜色鲜明的对话框 好了下面就开始讲解如何制作模仿win			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/949Lb13.html" rel="bookmark" class="title">交换、路由与防火墙手记&lpar;3&rpar;</a>
					<div>
						交接机的名称.时钟以及IP地址配置 &lt;Huawei&gt;system-viewEnter system view, return user view with Ctrl+Z. [Huawei] ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Z0KPEw3.html" rel="bookmark" class="title">习题1</a>
					<div>
						题目如下 编程实现:设n为1~1500间的所有整数,按照如下要求计算和输出. 1.判断并输出n中能被3和5和7同时整除的数的个数: 2.判断并输出n中能被3或5或7整除的数的个数: 3.判断并输出n中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/r0ayRR0.html" rel="bookmark" class="title">shell进阶</a>
					<div>
						◆  条件选择 if语句 单分支 if 判断条件;then 条件为真的分支代码 fi 双分支 if 判断条件; then 条件为真的分支代码 else 条件为假的分支代码 fi 多分支 if 判断条件 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Z0YPjqM.html" rel="bookmark" class="title">Java环境配置</a>
					<div>
						对于Java开发者而言,首先需要配置Java开发环境. 你需要一个JDK,而不是JRE! 1. 下载地址 Oracle收购Sun之后,Java新版本由Oracle发布. 目前的版本为 JDK 1.8  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MEogLD3.html" rel="bookmark" class="title">Java之旅hibernate（8）&mdash;&mdash;基本关系映射</a>
					<div>
						何为关系,何为映射,关系这个词想必大家都不陌生.比方你和老师之间是师生关系,你和父母之间是父子或者父女(母子或者母女关系). 关系是存在某种联系物体之间产生的.什么都是可能的.比方你和工具,你仅仅能使 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyjqmY0.html" rel="bookmark" class="title">list comprehensions列表解析</a>
					<div>
						没有使用列表解析: 1 x =[] 2 for i in (1, 2, 3): 3 x.append(i) 4 5 &quot;&quot;&quot; 6 &gt;&gt;&gt; x 7 [1,  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWLzZL0.html" rel="bookmark" class="title">查看系统负载：w</a>
					<div>
						[[email protected] ~]# w 11:45:15 up 1 day, 1 user, load average: 0.08, 0.18, 0.08 USER TTY FROM [em ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M6518G4.html" rel="bookmark" class="title">j2ee 分布式布署  RPC基础知识</a>
					<div>
						一.什么是RPC     远程过程调用(RPC)是一个协议,程序可以使用这个协议使用网络中另一个服务器中某程序的服务,而不需要知道网络细节 二.RPC模型     .  c/s模式     .  基于 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVzX7xM.html" rel="bookmark" class="title">使用字符设备驱动</a>
					<div>
						应用程序通过操作字符设备文件来控制字符设备,字符设备文件通过主设备号操作字符设备. 创建字符设备文件 使用mknod命令 mknod    /dev/文件名    c    主设备号   次设备号   ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/382XDAM.html" rel="bookmark" class="title">ios copy 和 retain  字符串</a>
					<div>
						1 @property (retain, nonatomic) NSString *retainStr; 2 @property (copy, nonatomic) NSString *copyStr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mmo5lQ3.html" rel="bookmark" class="title">app应用图标尺寸</a>
					<div>
						app应用图标尺寸,布布扣,bubuko.com					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NjQAy4.html" rel="bookmark" class="title">在交叉编译中使用最新版的SS</a>
					<div>
						因为旧版本的ss-local总是出现 shake hands failed 错误, 打算用最新的版本试试, 所以尝试在编译中使用最新版的shadowsocks. 项目地址 Shadowsocks-li ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41zmQoM.html" rel="bookmark" class="title">整合Spring Data JPA与Spring MVC&colon; 分页和排序</a>
					<div>
						之前我们学习了如何使用Jpa访问关系型数据库.比较完整Spring MVC和JPA教程请见Spring Data JPA实战入门,Spring MVC实战入门. 通过Jpa大大简化了我们对数据库的开发 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0ekm9J4.html" rel="bookmark" class="title">jQuery 自定义扩展，与&dollar;冲突处理</a>
					<div>
						&lt;!DOCTYPE html&gt; &lt;html&gt; &lt;head&gt; &lt;meta charset=&quot;UTF-8&quot;&gt; &lt;title&gt; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBjb7gM.html" rel="bookmark" class="title">stone jaw crushers</a>
					<div>
						The linear screen is a new kind of high efficiency screening equipment which vibrates with a vibrati ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3Op6bZ4.html" rel="bookmark" class="title">VLOOKUP多条件查找不使用辅助列</a>
					<div>
						问题描述: 可能很多人在使用VLOOKUP的时候,对于多条件时,则会使用辅助列进行查找,那么不使用辅助列是否也可以呢? 答案是:必须可以. 问题处理: 1.使用辅助列 2.不使用辅助列的操作如下: 公 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXDKYzM.html" rel="bookmark" class="title">怎样删除 Windows&period;old 目录</a>
					<div>
						问题描写叙述: windows系统升级一向会造成一个问题,就是在系统盘中会保留windows的设置文件:windows.old,会占用非常大存储空间. 用传统方式删除会提示没有权限. 本博客将提出一种 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dEGGr3.html" rel="bookmark" class="title">2016 CCPC 网络赛 B 高斯消元 C 树形dp&lpar;待补&rpar; G 状压dp&plus;容斥&lpar;待补&rpar; H 计算几何</a>
					<div>
						2016 CCPC 网络赛 A - A water problem 水题,但读题有个坑,输入数字长度很大.. B - Zhu and 772002 题意:给出n个数(给出的每个数的质因子最大不超过20 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38koYR0.html" rel="bookmark" class="title">UDP聊天程序------java</a>
					<div>
						通过键盘录入获取要发送的信息. 将发送和接收分别封装到两个线程中. package cn.hncu.UDP; &lt;span style=&quot;font-size:32px;color:#ff ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mmw5gB3.html" rel="bookmark" class="title">&lbrack;C&num;参考&rsqb;主线程和子线程之间的参数传递</a>
					<div>
						几个进程在大多数情况下要包含很多的子线程,那么他们之间免不了的要互相传递很多的参数,那么参数怎么传递的呢? 主线程向子线程传递参数的方法 第一种方法:Thraed类有一个带参数的委托类型的重载形式,这 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.026 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
